/*
 * Copyright (C) 2003-2007 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */

package com.funambol.syncclient.spdm;

import java.io.PrintStream;
import java.io.PrintWriter;

/**
 * This class represents a device manager error. It keeps track of the causing
 * exception, if any.
 *
 *
 * @version $Id: DMException.java,v 1.5 2007/06/18 09:49:45 luigiafassina Exp $
 */
public class DMException extends Exception {

    private Throwable cause = null;

    /**
     * Creates a new instance of <code>UpdateException</code> without detail message.
     */
    public DMException() {
    }


    /**
     * Constructs an instance of <code>DMException</code> with the specified detail message.
     * @param msg the detail message.
     */
    public DMException(final String msg) {
        super(msg);
    }

    /**
     * Constructs an instance of <code>DMException</code> with the specified detail message
     * and root cause.
     *
     * @param msg the detail message.
     * @param cause the root cause
     */
    public DMException(final String msg, final Throwable cause) {
        this(msg);
        this.cause = cause;
    }

    /**
     * Returns the root cause of this exception
     *
     * @return the cause of this exception if any, or null otherwise
     */
    public Throwable getCause() {
        return cause;
    }

    /**
     * Prints the exception and its cause (if any) stack trace
     */
    public void printStackTrace() {
        super.printStackTrace();
        if (cause != null) {
            System.err.println("Caused by:");
            cause.printStackTrace();
        }
    }
}
